<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OrderFinalStatus StructType
 * @subpackage Structs
 */
class OrderFinalStatus extends AbstractStructBase
{
    /**
     * The statusID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $statusID;
    /**
     * The statusSetDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $statusSetDate;
    /**
     * The finalStatusID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $finalStatusID;
    /**
     * The finalStatusSetDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $finalStatusSetDate;
    /**
     * The statusName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $statusName;
    /**
     * The statusENGName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $statusENGName;
    /**
     * The ReasonRrefusal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ReasonRrefusal;
    /**
     * The CarNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CarNumber;
    /**
     * The DriverPhone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DriverPhone;
    /**
     * The finalStatusName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $finalStatusName;
    /**
     * The finalStatusENGName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $finalStatusENGName;
    /**
     * Constructor method for OrderFinalStatus
     * @uses OrderFinalStatus::setStatusID()
     * @uses OrderFinalStatus::setStatusSetDate()
     * @uses OrderFinalStatus::setFinalStatusID()
     * @uses OrderFinalStatus::setFinalStatusSetDate()
     * @uses OrderFinalStatus::setStatusName()
     * @uses OrderFinalStatus::setStatusENGName()
     * @uses OrderFinalStatus::setReasonRrefusal()
     * @uses OrderFinalStatus::setCarNumber()
     * @uses OrderFinalStatus::setDriverPhone()
     * @uses OrderFinalStatus::setFinalStatusName()
     * @uses OrderFinalStatus::setFinalStatusENGName()
     * @param int $statusID
     * @param string $statusSetDate
     * @param int $finalStatusID
     * @param string $finalStatusSetDate
     * @param string $statusName
     * @param string $statusENGName
     * @param string $reasonRrefusal
     * @param string $carNumber
     * @param string $driverPhone
     * @param string $finalStatusName
     * @param string $finalStatusENGName
     */
    public function __construct($statusID = null, $statusSetDate = null, $finalStatusID = null, $finalStatusSetDate = null, $statusName = null, $statusENGName = null, $reasonRrefusal = null, $carNumber = null, $driverPhone = null, $finalStatusName = null, $finalStatusENGName = null)
    {
        $this
            ->setStatusID($statusID)
            ->setStatusSetDate($statusSetDate)
            ->setFinalStatusID($finalStatusID)
            ->setFinalStatusSetDate($finalStatusSetDate)
            ->setStatusName($statusName)
            ->setStatusENGName($statusENGName)
            ->setReasonRrefusal($reasonRrefusal)
            ->setCarNumber($carNumber)
            ->setDriverPhone($driverPhone)
            ->setFinalStatusName($finalStatusName)
            ->setFinalStatusENGName($finalStatusENGName);
    }
    /**
     * Get statusID value
     * @return int
     */
    public function getStatusID()
    {
        return $this->statusID;
    }
    /**
     * Set statusID value
     * @param int $statusID
     * @return \StructType\OrderFinalStatus
     */
    public function setStatusID($statusID = null)
    {
        // validation for constraint: int
        if (!is_null($statusID) && !(is_int($statusID) || ctype_digit($statusID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($statusID, true), gettype($statusID)), __LINE__);
        }
        $this->statusID = $statusID;
        return $this;
    }
    /**
     * Get statusSetDate value
     * @return string
     */
    public function getStatusSetDate()
    {
        return $this->statusSetDate;
    }
    /**
     * Set statusSetDate value
     * @param string $statusSetDate
     * @return \StructType\OrderFinalStatus
     */
    public function setStatusSetDate($statusSetDate = null)
    {
        // validation for constraint: string
        if (!is_null($statusSetDate) && !is_string($statusSetDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($statusSetDate, true), gettype($statusSetDate)), __LINE__);
        }
        $this->statusSetDate = $statusSetDate;
        return $this;
    }
    /**
     * Get finalStatusID value
     * @return int
     */
    public function getFinalStatusID()
    {
        return $this->finalStatusID;
    }
    /**
     * Set finalStatusID value
     * @param int $finalStatusID
     * @return \StructType\OrderFinalStatus
     */
    public function setFinalStatusID($finalStatusID = null)
    {
        // validation for constraint: int
        if (!is_null($finalStatusID) && !(is_int($finalStatusID) || ctype_digit($finalStatusID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($finalStatusID, true), gettype($finalStatusID)), __LINE__);
        }
        $this->finalStatusID = $finalStatusID;
        return $this;
    }
    /**
     * Get finalStatusSetDate value
     * @return string
     */
    public function getFinalStatusSetDate()
    {
        return $this->finalStatusSetDate;
    }
    /**
     * Set finalStatusSetDate value
     * @param string $finalStatusSetDate
     * @return \StructType\OrderFinalStatus
     */
    public function setFinalStatusSetDate($finalStatusSetDate = null)
    {
        // validation for constraint: string
        if (!is_null($finalStatusSetDate) && !is_string($finalStatusSetDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($finalStatusSetDate, true), gettype($finalStatusSetDate)), __LINE__);
        }
        $this->finalStatusSetDate = $finalStatusSetDate;
        return $this;
    }
    /**
     * Get statusName value
     * @return string|null
     */
    public function getStatusName()
    {
        return $this->statusName;
    }
    /**
     * Set statusName value
     * @param string $statusName
     * @return \StructType\OrderFinalStatus
     */
    public function setStatusName($statusName = null)
    {
        // validation for constraint: string
        if (!is_null($statusName) && !is_string($statusName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($statusName, true), gettype($statusName)), __LINE__);
        }
        $this->statusName = $statusName;
        return $this;
    }
    /**
     * Get statusENGName value
     * @return string|null
     */
    public function getStatusENGName()
    {
        return $this->statusENGName;
    }
    /**
     * Set statusENGName value
     * @param string $statusENGName
     * @return \StructType\OrderFinalStatus
     */
    public function setStatusENGName($statusENGName = null)
    {
        // validation for constraint: string
        if (!is_null($statusENGName) && !is_string($statusENGName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($statusENGName, true), gettype($statusENGName)), __LINE__);
        }
        $this->statusENGName = $statusENGName;
        return $this;
    }
    /**
     * Get ReasonRrefusal value
     * @return string|null
     */
    public function getReasonRrefusal()
    {
        return $this->ReasonRrefusal;
    }
    /**
     * Set ReasonRrefusal value
     * @param string $reasonRrefusal
     * @return \StructType\OrderFinalStatus
     */
    public function setReasonRrefusal($reasonRrefusal = null)
    {
        // validation for constraint: string
        if (!is_null($reasonRrefusal) && !is_string($reasonRrefusal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reasonRrefusal, true), gettype($reasonRrefusal)), __LINE__);
        }
        $this->ReasonRrefusal = $reasonRrefusal;
        return $this;
    }
    /**
     * Get CarNumber value
     * @return string|null
     */
    public function getCarNumber()
    {
        return $this->CarNumber;
    }
    /**
     * Set CarNumber value
     * @param string $carNumber
     * @return \StructType\OrderFinalStatus
     */
    public function setCarNumber($carNumber = null)
    {
        // validation for constraint: string
        if (!is_null($carNumber) && !is_string($carNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($carNumber, true), gettype($carNumber)), __LINE__);
        }
        $this->CarNumber = $carNumber;
        return $this;
    }
    /**
     * Get DriverPhone value
     * @return string|null
     */
    public function getDriverPhone()
    {
        return $this->DriverPhone;
    }
    /**
     * Set DriverPhone value
     * @param string $driverPhone
     * @return \StructType\OrderFinalStatus
     */
    public function setDriverPhone($driverPhone = null)
    {
        // validation for constraint: string
        if (!is_null($driverPhone) && !is_string($driverPhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($driverPhone, true), gettype($driverPhone)), __LINE__);
        }
        $this->DriverPhone = $driverPhone;
        return $this;
    }
    /**
     * Get finalStatusName value
     * @return string|null
     */
    public function getFinalStatusName()
    {
        return $this->finalStatusName;
    }
    /**
     * Set finalStatusName value
     * @param string $finalStatusName
     * @return \StructType\OrderFinalStatus
     */
    public function setFinalStatusName($finalStatusName = null)
    {
        // validation for constraint: string
        if (!is_null($finalStatusName) && !is_string($finalStatusName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($finalStatusName, true), gettype($finalStatusName)), __LINE__);
        }
        $this->finalStatusName = $finalStatusName;
        return $this;
    }
    /**
     * Get finalStatusENGName value
     * @return string|null
     */
    public function getFinalStatusENGName()
    {
        return $this->finalStatusENGName;
    }
    /**
     * Set finalStatusENGName value
     * @param string $finalStatusENGName
     * @return \StructType\OrderFinalStatus
     */
    public function setFinalStatusENGName($finalStatusENGName = null)
    {
        // validation for constraint: string
        if (!is_null($finalStatusENGName) && !is_string($finalStatusENGName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($finalStatusENGName, true), gettype($finalStatusENGName)), __LINE__);
        }
        $this->finalStatusENGName = $finalStatusENGName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OrderFinalStatus
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
